#!/bin/bash
#************************************************************************
# Codelet Tuning Infrastructure
# Copyright (C) 2010-2015 Intel Corporation, CEA, GENCI, and UVSQ
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#************************************************************************

# Authors: Franck Talbart, Mathieu Bordet, Nicolas Petit

#Required
REPOSITORY=""
TAG1=""
TAG2=""
TAG3=""
TAG4=""

#Geting options
while getopts "r:a:b:c:d:h" OPTION
do
    case ${OPTION} in
        r)
            REPOSITORY=${OPTARG}
            ;;
        a)
            TAG1=${OPTARG}
            ;;
        b)
            TAG2=${OPTARG}
            ;;
        c)
            TAG3=${OPTARG}
            ;;
        d)
            TAG4=${OPTARG}
            ;;
        h)
            echo "$0 -r <repository> -a <tag1> -b <tag2> [-c <tag3>] [-d <tag4>]"
            exit 0
            ;;
        ?)
            echo "Use -h to know the list of options."
            exit 1
            ;;
    esac
done

NUM_TAG="2"
#Checking we have the minimal amount of information
[ "${REPOSITORY}" == "" ] && echo "You must provide a repository (-r option)!" && exit 1
[ "${TAG1}" == "" ] && echo "You must provide the 1st tag (-a option)!" && exit 1
[ "${TAG2}" == "" ] && echo "You must provide the 2nd tag (-b option)!" && exit 1
[ "${TAG3}" != "" ] && NUM_TAG="3"
[ "${TAG4}" != "" ] && NUM_TAG="4"

FILENAME_CSV="coverage_tag_${NUM_TAG}_${REPOSITORY}.csv"
FILENAME_XLSX="coverage_tag_${NUM_TAG}_${REPOSITORY}.xlsx"

# CSV is not necessary generated by export, so we create it
> $FILENAME_CSV
cti entry export csv "nb_sample:>=5 tag:$TAG1" "$REPOSITORY" loop -2 --filename="$FILENAME_CSV" --fields="alias,coverage_maqao"
[ -f $FILENAME_CSV ] && ./csv_to_xlsx.py "$FILENAME_CSV" "template_xlsx/coverage_tags_${NUM_TAG}.xlsx" sheet2 tmp.xlsx 1 A && ./insert_cell.py tmp.xlsx 2 S "$TAG1" sheet1
# Empty the CSV (if export does not generate it)
> $FILENAME_CSV
cti entry export csv "nb_sample:>=5 tag:$TAG2" "$REPOSITORY" loop -2 --filename="$FILENAME_CSV" --fields="alias,coverage_maqao"
[ -f $FILENAME_CSV ] &&  ./csv_to_xlsx.py "$FILENAME_CSV" tmp.xlsx sheet2 tmp2.xlsx 1 C && ./insert_cell.py tmp2.xlsx 2 T "$TAG2" sheet1 
> $FILENAME_CSV
[ "${TAG3}" == "" ] && mv tmp2.xlsx "$FILENAME_XLSX"
[ "${TAG3}" != "" ] && cti entry export csv "nb_sample:>=5 tag:$TAG3" "$REPOSITORY" loop -2 --filename="$FILENAME_CSV" --fields="alias,coverage_maqao"
[ "${TAG3}" != "" ] && [ -f $FILENAME_CSV ] &&  ./csv_to_xlsx.py "$FILENAME_CSV" tmp2.xlsx sheet2 tmp3.xlsx 1 E && ./insert_cell.py tmp3.xlsx 2 U "$TAG3" sheet1
> $FILENAME_CSV
[ "${TAG4}" == "" ] && [ "${TAG3}" != "" ] && mv tmp3.xlsx "$FILENAME_XLSX"
[ "${TAG4}" != "" ] && cti entry export csv "nb_sample:>=5 tag:$TAG4" "$REPOSITORY" loop -2 --filename="$FILENAME_CSV" --fields="alias,coverage_maqao"
[ "${TAG4}" != "" ] && [ -f $FILENAME_CSV ] &&  ./csv_to_xlsx.py "$FILENAME_CSV" tmp3.xlsx sheet2 "$FILENAME_XLSX" 1 G && ./insert_cell.py "$FILENAME_XLSX" 2 V "$TAG4" sheet1

[ -f tmp.xlsx ] &&  rm tmp.xlsx
[ -f tmp2.xlsx ] &&  rm tmp2.xlsx
[ -f tmp3.xlsx ] &&  rm tmp3.xlsx

echo "CSV and XLSX files have been generated in the current directory."
